From 4c1125014fc2114ff23e001ec45092a20a4987a9 Mon Sep 17 00:00:00 2001
From: Konstantin Oblaukhov <oblaukhov.konstantin@gmail.com>
Date: Fri, 17 Mar 2023 16:04:45 +0700
Subject: [PATCH 07/13] Device hot reboot.

---
 dkms.conf                      |   2 +-
 forward-v4l2/forward-v4l2-io.c |   2 +-
 forward/forward-core.c         | 113 ++++++++++++++++++++++++++-------
 forward/forward-ctl.c          |  31 +++++++--
 forward/forward-fd720.c        |   9 +++
 forward/forward-fd722.c        |   9 +++
 forward/forward-fd788.c        |   9 +++
 include/fd720_reg.h            |  20 ++++++
 include/fd788_reg.h            |  29 +++++++++
 include/forward-version.h      |   2 +-
 include/forward.h              |   3 +
 11 files changed, 197 insertions(+), 32 deletions(-)

diff --git a/dkms.conf b/dkms.conf
index dca6c47..a2f143e 100644
--- a/dkms.conf
+++ b/dkms.conf
@@ -1,5 +1,5 @@
 PACKAGE_NAME="forward"
-PACKAGE_VERSION="1.5.0"
+PACKAGE_VERSION="1.5.1"
 
 BUILT_MODULE_NAME[0]="forward"
 BUILT_MODULE_LOCATION[0]="forward/"
diff --git a/forward-v4l2/forward-v4l2-io.c b/forward-v4l2/forward-v4l2-io.c
index 2e8a83c..c4241e0 100644
--- a/forward-v4l2/forward-v4l2-io.c
+++ b/forward-v4l2/forward-v4l2-io.c
@@ -1163,7 +1163,7 @@ static int forward_v4l2_c_querycap(struct file *file, void *priv, struct v4l2_ca
 		snprintf((char *)cap->bus_info, sizeof(cap->bus_info), "PCI:%s",
 			 pci_name(io->v4l2->dev->pci_dev));
 	}
-	cap->version = LINUX_VERSION_CODE;
+	cap->version = FORWARD_VERSION_CODE;
 
 	switch (iodev->type) {
 	case V4L2_BUF_TYPE_VIDEO_CAPTURE:
diff --git a/forward/forward-core.c b/forward/forward-core.c
index 6ed978e..f33ae6a 100644
--- a/forward/forward-core.c
+++ b/forward/forward-core.c
@@ -33,6 +33,7 @@
 #include <linux/ctype.h>
 #include <linux/export.h>
 #include <linux/of.h>
+#include <linux/delay.h>
 
 #define FORWARD_MODULE_NAME "forward"
 
@@ -448,7 +449,7 @@ static void forward_fini_io(struct forward_dev *dev, int io)
 	dev->io[io].dev = NULL;
 }
 
-static void forward_remove_common(struct forward_dev *dev)
+static void forward_fini_device(struct forward_dev *dev)
 {
 	unsigned long sflags;
 	int i;
@@ -481,6 +482,92 @@ static void forward_remove_common(struct forward_dev *dev)
 	forward_vdma_remove(dev);
 
 	forward_irq_remove(dev);
+}
+
+static int forward_init_device(struct forward_dev *dev)
+{
+	int result;
+	int i;
+
+	result = forward_irq_probe(dev);
+	if (result)
+		goto fail;
+
+	result = forward_vdma_probe(dev);
+	if (result)
+		goto fail;
+
+	if (dev->cfg.io_number != 0) {
+		dev->io = devm_kzalloc(dev->parent_dev,
+				       dev->cfg.io_count * sizeof(struct forward_io), GFP_KERNEL);
+
+		for (i = 0; i < dev->cfg.io_count; i++) {
+			result = forward_init_io(dev, i);
+			if (result)
+				goto fail;
+		}
+	}
+
+	forward_vdma_enable(dev);
+
+fail:
+	return result;
+}
+
+int forward_reboot_device(struct forward_dev *dev)
+{
+	struct forward_extension *ext;
+	int status;
+
+	if (!dev->cfg.reboot) {
+		forward_warn(dev, "Device reboot unsupported");
+		return -ENOTSUPP;
+	}
+
+	mutex_lock(&dev->lock);
+
+	if (forward_ref_read(dev) != 1) {
+		forward_warn(dev, "Cannot reboot device, device is busy");
+		mutex_unlock(&dev->lock);
+		return -EBUSY;
+	}
+
+	forward_fini_device(dev);
+
+	forward_fini_registers(dev);
+
+	dev->cfg.reboot(dev);
+
+	// TODO: Platform dev remap
+	if (dev->pci_dev) {
+		pci_save_state(dev->pci_dev);
+	}
+
+	msleep(5000);
+
+	if (dev->pci_dev) {
+		pci_restore_state(dev->pci_dev);
+		pci_set_master(dev->pci_dev);
+	}
+
+	forward_init_registers(dev);
+
+	status = forward_init_device(dev);
+
+	mutex_unlock(&dev->lock);
+
+	mutex_lock(&forward_extensions_lock);
+	list_for_each_entry (ext, &forward_extensions, node)
+		forward_ext_bind(dev, ext);
+	mutex_unlock(&forward_extensions_lock);
+
+	return status;
+}
+EXPORT_SYMBOL(forward_reboot_device);
+
+static void forward_remove_common(struct forward_dev *dev)
+{
+	forward_fini_device(dev);
 
 	dev->cfg.fini(dev);
 
@@ -497,7 +584,6 @@ static void forward_remove_common(struct forward_dev *dev)
 
 static int forward_probe_common(struct forward_dev *dev)
 {
-	int i;
 	int result = 0;
 	struct forward_extension *ext;
 
@@ -552,33 +638,16 @@ static int forward_probe_common(struct forward_dev *dev)
 	list_add_tail(&dev->list, &forward_devices);
 	mutex_unlock(&forward_devices_lock);
 
+	forward_parse_mode(dev, FORWARD_DEFAULT_MODE);
+
 	result = forward_ctl_probe(dev);
 	if (result)
 		goto fail;
 
-	result = forward_irq_probe(dev);
+	result = forward_init_device(dev);
 	if (result)
 		goto fail;
 
-	result = forward_vdma_probe(dev);
-	if (result)
-		goto fail;
-
-	if (dev->cfg.io_number != 0) {
-		dev->io = devm_kzalloc(dev->parent_dev,
-				       dev->cfg.io_count * sizeof(struct forward_io), GFP_KERNEL);
-
-		for (i = 0; i < dev->cfg.io_count; i++) {
-			result = forward_init_io(dev, i);
-			if (result)
-				goto fail;
-		}
-	}
-
-	forward_vdma_enable(dev);
-
-	forward_parse_mode(dev, FORWARD_DEFAULT_MODE);
-
 	forward_info(dev, "Added successfully\n");
 
 	mutex_unlock(&dev->lock);
diff --git a/forward/forward-ctl.c b/forward/forward-ctl.c
index c699bbc..603dd1f 100644
--- a/forward/forward-ctl.c
+++ b/forward/forward-ctl.c
@@ -384,6 +384,26 @@ static ssize_t forward_attr_store_io_config(struct device *dev, struct device_at
 	return count;
 }
 
+static ssize_t forward_attr_store_reboot(struct device *dev, struct device_attribute *attr,
+					 const char *buf, size_t count)
+{
+	struct forward_dev *fdev = dev_get_drvdata(dev);
+	int status;
+
+	if (count < 1)
+		return -EINVAL;
+
+	if (buf[0] == '1')
+		status = forward_reboot_device(fdev);
+	else if (buf[0] == '0')
+		status = 0;
+	else
+		status = -EINVAL;
+
+	return status ? status : count;
+}
+
+static DEVICE_ATTR(reboot, S_IWUSR, NULL, forward_attr_store_reboot);
 static DEVICE_ATTR(software_id, S_IRUGO, forward_attr_show_software_id, NULL);
 static DEVICE_ATTR(hardware_id, S_IRUGO, forward_attr_show_hardware_id, NULL);
 static DEVICE_ATTR(name, S_IRUGO, forward_attr_show_name, NULL);
@@ -394,13 +414,10 @@ static DEVICE_ATTR(io_config, S_IWUSR | S_IWGRP | S_IRUGO, forward_attr_show_io_
 		   forward_attr_store_io_config);
 
 static struct attribute *forward_dev_attrs[] = {
-	&dev_attr_software_id.attr,
-	&dev_attr_hardware_id.attr,
-	&dev_attr_name.attr,
-	&dev_attr_mode.attr,
-	&dev_attr_extensions.attr,
-	&dev_attr_io_config.attr,
-	NULL,
+	&dev_attr_software_id.attr, &dev_attr_hardware_id.attr,
+	&dev_attr_name.attr,	    &dev_attr_mode.attr,
+	&dev_attr_extensions.attr,  &dev_attr_io_config.attr,
+	&dev_attr_reboot.attr,	    NULL,
 };
 
 static struct attribute_group forward_dev_attr_group = {
diff --git a/forward/forward-fd720.c b/forward/forward-fd720.c
index 12c13b0..f0216f7 100644
--- a/forward/forward-fd720.c
+++ b/forward/forward-fd720.c
@@ -37,6 +37,14 @@ static void fd720_fini(struct forward_dev *dev)
 {
 }
 
+static void fd720_reboot(struct forward_dev *dev)
+{
+	FD720_GlobalCSR g = FD720_GlobalCSR_R(dev->csr);
+	g.reboot = 1;
+	FD720_GlobalCSR_W(dev->csr, g);
+	// Board dies in ~2-5s
+}
+
 static void fd720_read_id(struct forward_dev *dev)
 {
 	int cap_addr = pci_find_ext_capability(dev->pci_dev, PCI_EXT_CAP_ID_DSN);
@@ -232,6 +240,7 @@ struct forward_dev_config fd720_cfg = {
 
 	.init = fd720_init,
 	.fini = fd720_fini,
+	.reboot = fd720_reboot,
 
 	.read_id = fd720_read_id,
 
diff --git a/forward/forward-fd722.c b/forward/forward-fd722.c
index 1e86574..a7081ba 100644
--- a/forward/forward-fd722.c
+++ b/forward/forward-fd722.c
@@ -145,6 +145,14 @@ static void fd722_fini(struct forward_dev *dev)
 		forward_si532x_fini(dev, &dev->pll);
 }
 
+static void fd722_reboot(struct forward_dev *dev)
+{
+	FD722_GlobalCSR g = FD722_GlobalCSR_R(dev->csr);
+	g.reboot = 1;
+	FD722_GlobalCSR_W(dev->csr, g);
+	// Board dies in ~2-5s
+}
+
 static void fd722_read_id(struct forward_dev *dev)
 {
 	int cap_addr = pci_find_ext_capability(dev->pci_dev, PCI_EXT_CAP_ID_DSN);
@@ -363,6 +371,7 @@ struct forward_dev_config fd722_cfg = {
 
 	.init = fd722_init,
 	.fini = fd722_fini,
+	.reboot = fd722_reboot,
 
 	.read_id = fd722_read_id,
 
diff --git a/forward/forward-fd788.c b/forward/forward-fd788.c
index 008dc77..5bf1916 100644
--- a/forward/forward-fd788.c
+++ b/forward/forward-fd788.c
@@ -82,6 +82,14 @@ static void fd788_fini(struct forward_dev *dev)
 	forward_si532x_fini(dev, &dev->pll);
 }
 
+static void fd788_reboot(struct forward_dev *dev)
+{
+	FD788_GlobalCSR g = FD788_GlobalCSR_R(dev->csr);
+	g.reboot = 1;
+	FD788_GlobalCSR_W(dev->csr, g);
+	// Board dies in ~2-5s
+}
+
 static void fd788_read_id(struct forward_dev *dev)
 {
 	int cap_addr = pci_find_ext_capability(dev->pci_dev, PCI_EXT_CAP_ID_DSN);
@@ -305,6 +313,7 @@ struct forward_dev_config fd788_cfg = {
 
 	.init = fd788_init,
 	.fini = fd788_fini,
+	.reboot = fd788_reboot,
 
 	.read_id = fd788_read_id,
 
diff --git a/include/fd720_reg.h b/include/fd720_reg.h
index 3f75a1b..dcf71cb 100644
--- a/include/fd720_reg.h
+++ b/include/fd720_reg.h
@@ -257,6 +257,26 @@ void __always_inline FD720_VideoInColorConversion_W(uint32_t *csr, unsigned int
 	__write_reg(csr, FD720_VideoInColorConversion_A(n), *((uint32_t *)&v));
 }
 
+typedef struct _FD720_GlobalCSR {
+	uint32_t videoReset : 1;
+	uint32_t icapRW : 1;
+	uint32_t reboot : 1;
+	uint32_t _unused3103 : 29;
+} __attribute__((packed)) FD720_GlobalCSR;
+
+#define FD720_GlobalCSR_A (0x80)
+
+FD720_GlobalCSR __always_inline FD720_GlobalCSR_R(uint32_t *csr)
+{
+	uint32_t r = __read_reg(csr, FD720_GlobalCSR_A);
+	return *((FD720_GlobalCSR *)&r);
+}
+
+void __always_inline FD720_GlobalCSR_W(uint32_t *csr, FD720_GlobalCSR v)
+{
+	__write_reg(csr, FD720_GlobalCSR_A, *((uint32_t *)&v));
+}
+
 typedef struct _FD720_TemperatureMonitor {
 	uint32_t temperature : 10;
 	uint32_t maxTemperature : 10;
diff --git a/include/fd788_reg.h b/include/fd788_reg.h
index 87f9ab0..ab670c2 100644
--- a/include/fd788_reg.h
+++ b/include/fd788_reg.h
@@ -27,6 +27,35 @@
 #define __read_reg(csr, addr) ioread32(&csr[addr])
 #define __write_reg(csr, addr, v) iowrite32(v, &csr[addr])
 
+typedef struct _FD788_GlobalCSR {
+	uint32_t videoReset : 1;
+	uint32_t vpllReset : 1;
+	uint32_t reconfigure : 1;
+	uint32_t vpllClkSelect : 1;
+	uint32_t icapRW : 1;
+	uint32_t reboot : 1;
+	uint32_t _unused1506 : 10;
+	uint32_t vpllLocked : 1;
+	uint32_t qpll0Locked : 1;
+	uint32_t qpll1Locked : 1;
+	uint32_t vpllClk1Bad : 1;
+	uint32_t vpllClk2Bad : 1;
+	uint32_t _unused3121 : 11;
+} __attribute__((packed)) FD788_GlobalCSR;
+
+#define FD788_GlobalCSR_A (0xC0)
+
+FD788_GlobalCSR __always_inline FD788_GlobalCSR_R(uint32_t *csr)
+{
+	uint32_t r = __read_reg(csr, FD788_GlobalCSR_A);
+	return *((FD788_GlobalCSR *)&r);
+}
+
+void __always_inline FD788_GlobalCSR_W(uint32_t *csr, FD788_GlobalCSR v)
+{
+	__write_reg(csr, FD788_GlobalCSR_A, *((uint32_t *)&v));
+}
+
 typedef struct _FD788_TemperatureMonitor {
 	uint32_t temperature : 10;
 	uint32_t maxTemperature : 10;
diff --git a/include/forward-version.h b/include/forward-version.h
index 5379007..490ed18 100644
--- a/include/forward-version.h
+++ b/include/forward-version.h
@@ -26,7 +26,7 @@
 
 #define FORWARD_VERSION_MAJOR 1
 #define FORWARD_VERSION_MINOR 5
-#define FORWARD_VERSION_PATCH 0
+#define FORWARD_VERSION_PATCH 1
 
 #define _FORWARD_VERSION_STR_HELPER(x) #x
 #define _FORWARD_VERSION_STR(x) _FORWARD_VERSION_STR_HELPER(x)
diff --git a/include/forward.h b/include/forward.h
index 8fcbe0c..36cedff 100644
--- a/include/forward.h
+++ b/include/forward.h
@@ -70,6 +70,7 @@ struct forward_dev_config {
 
 	int (*init)(struct forward_dev *dev);
 	void (*fini)(struct forward_dev *dev);
+	void (*reboot)(struct forward_dev *dev);
 
 	void (*read_id)(struct forward_dev *dev);
 
@@ -178,6 +179,8 @@ int forward_io_ref_read(struct forward_io *io);
 int forward_switch_mode(struct forward_dev *dev, const char *mode_string);
 bool forward_has_mode(struct forward_dev *dev, const char *mode);
 
+int forward_reboot_device(struct forward_dev *dev);
+
 int forward_switch_io(struct forward_io *io, enum forward_io_state state);
 
 int forward_toggle_streaming(struct forward_io *io, bool enabled);
-- 
2.39.1


